<ad-watchlists>
    <div class="popup-ovelray" id="watchlists-popup" style="display:none">
        <div class="popup-window" if="{ state.show_watchlist_options }">
            <div class="popup-heading">
                <div class="title">Αποθήκευση σε...</div>
                <a href="#" class="close" onclick="{ close_watchlist }">&times;</a>
            </div>

            <div class="popup-body scrollable">
                <ul class="list-options">
                    <li class="list-item" each="{ watchlist in state.watchlists }">
                        <div class="custom-control custom-checkbox">
                            <input type="checkbox" class="custom-control-input" id="wl{ watchlist.id }" onchange="{ select_watchlist }" checked="{ state.watchlist.id == watchlist.id }">
                            <label class="custom-control-label" for="wl{ watchlist.id }">{ watchlist.title }</label>
                        </div>

                    </li>
                </ul>
            </div>
            <div class="popup-footer text-center" if="{ !state.new_watchlist }">
                <button class="btn-link" onclick="{ update_watchlist }" disabled="{ !state.is_dirty }">ΕΝΗΜΕΡΩΣΗ</a>
            </div>
            <div class="popup-footer" if="{ !state.new_watchlist }">
                <a href="#" class="text-center" style="display:block;" onclick="{ new_watchlist }">ΔΗΜΙΟΥΡΓΙΑ ΝΕΑΣ ΛΙΣΤΑΣ</a>
            </div>
            <div class="popup-footer" if="{ state.new_watchlist }">
                <form onsubmit="{ create_watchlist }">
                    <div class="form-group">
                        <label>Όνομα</label>
                        <input type="text" class="form-control" data-ref="watchlist_title" placeholder="όνομα λίστας" required>
                    </div>
                    <div class="popup-footer-left">
                        <a href="#" class="btn-link" onclick="{ cancel_create_watchlist }">ΑΚΥΡΩΣΗ</a>
                    </div>
                    <div class="popup-footer-right">
                        <input type="submit" class="btn-link" value="ΑΠΟΘΗΚΕΥΣΗ">
                    </div>
                </form>
            </div>

            <loader-icon class="control-loader" if="{ state.loading }"></loader-icon>
        </div>
    </div>

    <script>
        this.state = {
            ad_id: 0,
            watchlists: [],
            watchlist: {}, // selected watchlist
            last_watchlist_id: 0, // last selected watchlist
            show_watchlist_options: false,
            new_watchlist: false,

            is_dirty: false,
            loading: false,
        }


        this.toggle_loader = value => {
            this.state.loading = value;
            this.update();
        }


        // open watchlist popup
        this.open_watchlist = ad_id => {

            this.state.ad_id = ad_id;

            var tag = this;
            request(
                'ad_watchlist_list',
                {
                    ad: this.state.ad_id,
                },
                function(result) {
                    tag.state.member_id = result.member_id;
                    tag.state.watchlists = result.watchlists;

                    tag.state.watchlists.map (item => {
                        if (!item.title) {
                            item.title = "χωρίς τίτλο";
                        }
                    })

                    // if no member watchlists
                    if (!tag.state.watchlists.length) {
                        // Add default watchlist
                        tag.state.watchlists.push({
                            id: 0,
                            member_id: result.member_id,
                            title: "H λίστα μου",
                        });
                    }

                    tag.state.watchlist = result.watchlist ? result.watchlist : {};
                    tag.state.last_watchlist_id = result.watchlist ? result.watchlist.id : 0;
                    tag.state.is_dirty = false;

                    tag.update();

                    // show watchlist popup
                    $('#watchlists-popup').fadeIn('fast', function() {
                        tag.state.show_watchlist_options = true;                    
                        tag.update();
                    });
                }, null, this.toggle_loader
            );
        }


        this.close_watchlist = event => {
            if (typeof event !== 'undefined') {
                event.preventDefault();
            }

            var tag = this;
            $('#watchlists-popup').fadeOut('fast', function() {
                // clear state
                tag.state.watchlists = [];
                tag.state.watchlist = {};
                tag.state.last_watchlist_id = 0;
                tag.state.show_watchlist_options = false;
                tag.state.new_watchlist = false;
                tag.state.is_dirty = false;

                tag.update();
            });
        }


        this.select_watchlist = event => {
            this.state.watchlist = event.target.checked ? event.item.watchlist : {};
            this.state.is_dirty = true;
        }


        this.new_watchlist = event => {
            event.preventDefault();

            this.state.new_watchlist = true;
        }


        this.create_watchlist = event => {
            event.preventDefault();

            // add new watchlist in state
            this.state.watchlist = {
                id: 0,
                member_id: this.state.member_id,
                title: this.refs.watchlist_title.value,
            }

            this.state.new_watchlist = false;

            // update ad watchlist
            this.update_watchlist();
        }


        this.cancel_create_watchlist = event => {
            event.preventDefault();
            this.state.new_watchlist = false;
        }


        this.update_watchlist = event => {
            if (typeof event !== 'undefined') {
                event.preventDefault();
            }

            if (this.state.watchlist.id != null) {
                // ad added in wathlist
                var watchlist = this.state.watchlist;
                var message = 'Η αγγελία προστέθηκε στη λίστα "' + this.state.watchlist.title + '"';
            } else {
                // ad removed from watchlists
                var watchlist = null;
                var message = 'Η αγγελία αφαιρέθηκε από τις λίστες σας.';
            }

            var tag = this;
            request(
                'ad_watchlist_save',
                {
                    'ad': this.state.ad_id,
                    'watchlist': watchlist,
                },
                function(result) {                                      
                    if (watchlist) {
                        $('#ad-' + tag.state.ad_id + ' .control-watchlist .badge-check').show();
                    } else {
                        $('#ad-' + tag.state.ad_id + ' .control-watchlist .badge-check').hide();
                    }

                    tag.close_watchlist();
                    popup_message(message);
                },
                null,
                this.toggle_loader
            );
        }


        this.on("mount", function() {
            var tag = this;
            // close watchlist if click on popup overlay
            $('#watchlists-popup').on("click", function(event) {
                if ($(event.target).attr('id') == 'watchlist') {
                    tag.close_watchlist();
                }
            });
        });
    </script>
</ad-watchlists>